/**
 * @function doSend
 */
"use strict";

const uuid = require('uuid'),
    Promise = require('apemanpromise');

/** @lends doSend */
function doSend(User, Verify, userId, key, value, expireDuration) {
    return User
        .findById(userId)
        .then(user => {
            if (!user) {
                return null;
            }
            if (!value) {
                return null;
            }
            return Verify
                .findOrCreate({
                    where: {
                        user_id: user.id,
                        verify_target: value
                    },
                    defaults: {
                        user_id: user.id
                    }
                })
                .then(verify => [].concat(verify || [])[0])
                .then(verify =>
                    verify.update({
                        expire_at: new Date(new Date() + expireDuration),
                        verify_target_kind: key,
                        verify_target: value,
                        verify_token: uuid.v4().replace(/\-/g, ''),
                        verified: false
                    })
                )
        })
}

module.exports = doSend;